/*
 * Copyright (c) 2016-2020 Marco Hladik <marco@icculus.org>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF MIND, USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
 * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#define GS_RENDERFX

#ifdef GS_RENDERFX
enum
{ 
	RM_NORMAL,
	RM_COLOR,
	RM_TEXTURE,
	RM_GLOW,
	RM_SOLID,
	RM_ADDITIVE,
	RM_TRIGGER
};

enum
{
	RFX_NORMAL,
	RFX_SLOWPULSE,
	RFX_FASTPULSE,
	RFX_SLOWWIDEPULSE,
	RFX_FASTWIDEPULSE,
	RFX_SLOWFADEAWAY,
	RFX_FASTFADEAWAY,
	RFX_SLOWBECOMESOLID,
	RFX_FASTBECOMESOLID,
	RFX_SLOWSTROBE,
	RFX_FASTSTROBE,
	RFX_FASTERSTROBE,
	RFX_SLOWFLICKER,
	RFX_FASTFLICKER,
	RFX_CONSTANTGLOW,
	RFX_DISTORT,
	RFX_HOLOGRAM
};
#endif

enumflags
{
	BASEFL_CHANGED_ORIGIN,
	BASEFL_CHANGED_ANGLES,
	BASEFL_CHANGED_MODELINDEX,
	BASEFL_CHANGED_SIZE,
	BASEFL_CHANGED_SOLID,
	BASEFL_CHANGED_FRAME,
	BASEFL_CHANGED_SKIN,
	BASEFL_CHANGED_MOVETYPE,
	BASEFL_CHANGED_EFFECTS,
	BASEFL_CHANGED_BODY,
#ifdef GS_RENDERFX
	BASEFL_CHANGED_RENDERCOLOR,
	BASEFL_CHANGED_RENDERAMT,
	BASEFL_CHANGED_RENDERFX,
	BASEFL_CHANGED_RENDERMODE,
#else
	BASEFL_CHANGED_ALPHA,
#endif
}; 
