/*
 * Copyright (c) 2016-2020 Marco Hladik <marco@icculus.org>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF MIND, USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
 * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

void Strings_Init(void)
{
	filestream stringslst;
	string lstline;

	/* Populate the strings array with default hl.exe values*/
	m_reslbl[IDS_LANGUAGE] = "English";
	m_reslbl[IDS_BORDERLESS_REGFAIL] = "Could not register Half-Life edit control class.";
	m_reslbl[IDS_CHAT_IGNORE_MISLINKED] = "Ignoring mislinked chat room";
	m_reslbl[IDS_CHAT_IGNORE_UNLINKED] = "Ignoring unlinked chat room";
	m_reslbl[IDS_CREATE_MAPSCHANGED] = "The number of maps in the map directory changed.";
	m_reslbl[IDS_CREATE_LIBLISTBAD] = "The file 'liblist.gam' in the game directory was malformed, see /valve/liblist.gam for format info.";
	m_reslbl[IDS_SOCKET_CONNECTIONFAILURE] = "Your network connection may have failed, continuing anway...";
	m_reslbl[IDS_PLAYERINFO_NOMEM] = "Could not allocate memory for player information instance.";
	m_reslbl[IDS_CHAT_NOCONNECTION] = "Could not create chat server connection.";
	m_reslbl[IDS_CHAT_NOSTREAM] = "Could not create chat server data stream.";
	m_reslbl[IDS_CHAT_NOSELECT] = "Could not prepare chat server client for connection.";
	m_reslbl[IDS_CONTROLS_DELETE_LINKED] = "Deletion of linked key action item.";
	m_reslbl[IDS_CONTROLS_KBLIST_EMPTY] = "Keyboard bindings file 'kb_act.lst' is empty.";
	m_reslbl[IDS_CONTROLS_KBLIST_PARSEERROR] = "Error parsing bindings file 'kb_act.lst'.";
	m_reslbl[IDS_CONTROLS_KBKEYS_EMPTY] = "Keyboard bindings file 'kb_keys.lst' is empty.";
	m_reslbl[IDS_CONTROLS_KBKEYS_PARSEERROR] = "Error parsing file 'kb_keys.lst'.";
	m_reslbl[IDS_CONTROLS_KBKEYS_OVERFLOW] = "Too many actions in file 'kb_keys.lst'.";
	m_reslbl[IDS_PROFILE_COLOR] = "Colors";
	m_reslbl[IDS_MAIN_NOCAPS] = "Could not query graphics device capabilities.";
	m_reslbl[IDS_MAIN_INSUFFICIENTCAPS] = "Your graphics card does not support a necessary raster operation.";
	m_reslbl[IDS_MAIN_REGWNDCLSFAIL] = "Could not register Half-Life's window class.";
	m_reslbl[IDS_MAIN_INSUFFICIENTSOCKETS] = "Insufficient number of windows sockets, networking may not operate correctly.";
	m_reslbl[IDS_MAIN_MEMMAPFAILURE] = "Memory-mapped file i/o initialization failed.";
	m_reslbl[IDS_PROFILE_NOMEM] = "Couldn't allocate memory for player profile, exiting.";
	m_reslbl[IDS_BTN_STRANGESIZE] = "Button face bitmap graphics file sizes appear invalid.";
	m_reslbl[IDS_MAIN_NOUSERMSGS] = "Could not register user messages.";
	m_reslbl[IDS_MAIN_NOFILEMAPPING] = "Could not create file mapping to engine.";
	m_reslbl[IDS_MAIN_NOMEMMAPCONNECT] = "Could not connect to server '%s'.";
	m_reslbl[IDS_MSG_OVERFLOW] = "SZ_GetSpace overflow without m_bAllowOverflow set";
	m_reslbl[IDS_MSG_REQTOOBIG] = "SZ_GetSpace requested length is greater than available buffer size.";
	m_reslbl[IDS_MULTI_NOROOMSTATIC] = "Could not allocate room static text control.";
	m_reslbl[IDS_MULTI_NOROOMTAB] = "Could not allocate room tab control.";
	m_reslbl[IDS_MULTI_NOCHATWINDOW] = "Could not allocate chat display window control.";
	m_reslbl[IDS_MULTI_NOCHATINPUT] = "Could not allocate chat text input control.";
	m_reslbl[IDS_MULTI_NOUSERLIST] = "Could not allocate chat user list control.";
	m_reslbl[IDS_MULTI_NOSERVERLIST] = "Could not allocate server browser list control.";
	m_reslbl[IDS_MULTI_NOSELECTION] = "No servers selected.";
	m_reslbl[IDS_MULTI_NOARCHIVE] = "Half-Life could not open the server list archive file:  '%s'.";
	m_reslbl[IDS_CHAT_USER_NOMEM] = "Could not allocate space for new chat rrom user.";
	m_reslbl[IDS_MULTI_SERVER_NOMEM] = "Could not allocate space for a new server.";
	m_reslbl[IDS_MULTI_MASTER_BADLISTFILE] = "Could not open master server list file.";
	m_reslbl[IDS_MULTI_NODIALOG] = "SetDialog with no dialog!";
	m_reslbl[IDS_PROFILE_REQUIRED] = "You must create or select a player profile to continue.";
	m_reslbl[IDS_ODCOMBO_REGFAIL] = "Could not register Half-Life combobox class.";
	m_reslbl[IDS_ODEDIT_REGFAIL] = "Could not register Half-Life edit control class.";
	m_reslbl[IDS_ODLIST_REGFAIL] = "Could not register Half-Life list control class.";
	m_reslbl[IDS_ODSCROLL_REGFAIL] = "Could not register Half-Life scrollbar class.";
	m_reslbl[IDS_ODSLIDER_REGFAIL] = "Could not register Half-Life slider class.";
	m_reslbl[IDS_ODTAB_REGFAIL] = "Could not register Half-Life tab control class.";
	m_reslbl[IDS_PROFILE_NICKREMOVEFAIL] = "Could not remove chat nicknames.";
	m_reslbl[IDS_PROFILE_NOPROFILE] = "No chosen profile.";
	m_reslbl[IDS_QUICK_NOSERVERS] = "Could not locate any active %s servers with available slots.";
	m_reslbl[IDS_QUICK_NOACTIVE] = "Could not connect to any active %s servers.";
	m_reslbl[IDS_README_NOMEM] = "Could not allocate buffer for readme:  %i bytes";
	m_reslbl[IDS_ROOM_BADNAME] = "The room name was invalid.";
	m_reslbl[IDS_SINGLE_NOSELECTION] = "You must select a save game slot from the available slots.";
	m_reslbl[IDS_SINGLE_CANTSAVE] = "You must be playing in a single player game to save.";
	m_reslbl[IDS_ODLISTBOX_REGFAIL] = "Could not register Half-Life list box class.";
	m_reslbl[IDS_DIB_OPENFAIL] = "Could not open bitmap file '%s'.";
	m_reslbl[IDS_MCI_OPENFAIL] = "Could not open MCI file for playback:  %s";
	m_reslbl[IDS_MCI_GETIDFAIL] = "Could not get MCI Device ID for MCI device";
	m_reslbl[IDS_MCI_WINDOWFAIL] = "Could not set up MCI window for playback of MCI device:  %s";
	m_reslbl[IDS_MCI_PUTFAIL] = "Could not display MCI playback of MCI device in window: %s";
	m_reslbl[IDS_MCI_SEEKFAIL] = "Could not seek to start of MCI data:  %s";
	m_reslbl[IDS_MCI_BREAKFAIL] = "Could not set break key on MCI data:  %s";
	m_reslbl[IDS_MCI_PLAYFAIL] = "Could not start playback of MCI data:  %s";
	m_reslbl[IDS_MCI_STOPFAIL] = "Could not stop playback of MCI data:  %s";
	m_reslbl[IDS_MCI_CLOSEFAIL] = "Could not close MCI data:  %s";
	m_reslbl[IDS_CONTROLS_RESTOREFAIL] = "Could not restore default bindings for player.";
	m_reslbl[IDS_SND_BADNAME] = "Invalid sound name";
	m_reslbl[IDS_PROFILE_ALLOCFAIL] = "Could not allocate space for key binding";
	m_reslbl[IDS_AUDIO_NOPROFILE] = "Can't change audio settings without a current player profile.";
	m_reslbl[IDS_VIDEO_NOPROFILE] = "Can't change video settings without a current player profile.";
	m_reslbl[IDS_CONTROLS_KEYHELP] = "Use your mouse or the arrow keys to select an item.  Double-click or press Enter to change an item.  Press Delete to clear an item.";
	m_reslbl[IDS_ENDDEMO_URL] = "valve/media/order/default.html";
	m_reslbl[IDS_ORDER_URL] = "valve/media/order/default.html";
	m_reslbl[IDS_LOADSAVE_HINT] = "During play, you can quickly save your game by pressing %s. Load this game again by pressing %s.";
	m_reslbl[IDS_LAUNCHER_BUTTONSIZE] = "156 26";
	m_reslbl[IDS_MEM_INSUFFICIENT] = "Your system reported only %.2fK of physical memory, Half-Life requires at least 16MB.";
	m_reslbl[IDS_MEM_ALLOCFAIL] = "Half-Life was unable to allocate %.2fK of memory.";
	m_reslbl[IDS_EVENT_CREATEFAIL] = "Half-Life was unable to create a system object.";
	m_reslbl[IDS_OSVER_FAIL] = "Half-Life was unable to retreive system information.";
	m_reslbl[IDS_OSVER_OUTDATED] = "Half-Life requires Windows/95 or Windows/NT and above.";
	m_reslbl[IDS_OSVER_NTSP3] = "Half-Life requires Service Pack 3 or above";
    //m_reslbl[IDS_OSVER_16BIT] = "Half-Life requires 16 bit color. Please change your desktop settings to HiColor. Sometimes this is called] = "";32767 colors";"; or] = "";65535 colors";";.";
	m_reslbl[IDS_BINDING_ACTIONHEADING] = "Action";
	m_reslbl[IDS_BINDING_PRIMARYHEADING] = "Key / button";
	m_reslbl[IDS_BINDING_ALTERNATEHEADING] = "Alternate";
	m_reslbl[IDS_BINDING_PROMPT] = "Press a key or button.";
	m_reslbl[IDS_URL_BROWSERFAIL] = "Half-Life was unable to display the web page '%s', please make sure you have a web browser installed and that the association for opening .htm files is valid.";
	m_reslbl[IDS_SAVELOAD_TIMECOL] = "Time";
	m_reslbl[IDS_SAVELOAD_GAMECOL] = "Game";
	m_reslbl[IDS_SAVELOAD_ELAPSEDCOL] = "Elapsed Time";
	m_reslbl[IDS_SERVER_GAMESERVER] = "Game";
	m_reslbl[IDS_SERVER_SPEED] = "Net Spd";
	m_reslbl[IDS_SERVER_MAP] = "Map";
	m_reslbl[IDS_SERVER_PLAYERS] = "Players/Max";
	m_reslbl[IDS_SERVER_GAME] = "Game Type";
	m_reslbl[IDS_SERVER_NETWORK] = "Network";
	m_reslbl[IDS_QUERY_STARTING] = "Starting...";
	m_reslbl[IDS_QUERY_COMPLETED] = "%s completed.";
	m_reslbl[IDS_SERVER_REMOVE] = "Permanently remove %i servers from list?";
	m_reslbl[IDS_SERVER_CONNECT] = "Initiating connection to %s...";
	m_reslbl[IDS_SERVER_LANTAG] = "Lan";
	m_reslbl[IDS_SERVER_INTERNETTAG] = "Internet";
	m_reslbl[IDS_SERVER_MENU_CONNECT] = "Connect";
	m_reslbl[IDS_SERVER_MENU_PLAYERINFO] = "Show player and rule information";
	m_reslbl[IDS_SERVER_MENU_RULEINFO] = "Show rule information";
	m_reslbl[IDS_SERVER_MENU_FILTER] = "Filter server";
	m_reslbl[IDS_SERVER_MENU_ADDTOFAVORITE] = "Add to favorites";
	m_reslbl[IDS_SERVER_MENU_REMOVEFROMFAV] = "Remove from favorites";
	m_reslbl[IDS_SERVER_MENU_REMOVE] = "Permanently remove server";
	m_reslbl[IDS_SERVER_MENU_NOPLAYERINFO] = "No player information available";
	m_reslbl[IDS_SERVER_MENU_NOLANPLAYERINFO] = "Player information is not available for Lan games";
	m_reslbl[IDS_SAVELOAD_QUICKLISTTEXT] = "[quick] %s";
	m_reslbl[IDS_SAVELOAD_AUTOLISTITEM] = "[autosave] %s";
	m_reslbl[IDS_PLAYERINFO_NUMBER] = "#";
	m_reslbl[IDS_PLAYERINFO_NAME] = "Player Name";
	m_reslbl[IDS_PLAYERINFO_KILLS] = "Kills";
	m_reslbl[IDS_PLAYERINFO_TIME] = "Time";
	m_reslbl[IDS_PLAYERINFO_SUIT] = "HEV Suit";
	m_reslbl[IDS_QUICK_REQUEST] = "Requesting list of servers..., %.2f seconds left";
	m_reslbl[IDS_QUICK_GOTLIST] = "List received...";
	m_reslbl[IDS_QUICK_CONTACTING] = "Contacting servers...";
	m_reslbl[IDS_QUICK_COMPLETEDSERVER] = "%s completed.";
	m_reslbl[IDS_SAVE_NEWCOMMENT] = "New Saved Game";
	m_reslbl[IDS_SAVE_NEWTIME] = "New";
	m_reslbl[IDS_SAVE_NEWFILETIME] = "Current";
	m_reslbl[IDS_DDRAW_FAILEINIT] = "Direct Draw Init Failed (%08lx):%s\n";
	m_reslbl[IDS_DDRAW_DX4FAIL] = "Direct Draw 4 Init Failed (%08lx):%s\n";
	m_reslbl[IDS_VIDEO_MODECOL] = "Display mode";
	m_reslbl[IDS_ROOM_NAMECOL] = "Name";
	m_reslbl[IDS_ROOM_PEOPLECOL] = "People";
	m_reslbl[IDS_ROOM_SERVERSCOL] = "Servers";
	m_reslbl[IDS_DDRAW_REQUIRED] = "Half-Life requires DirectDraw";
	m_reslbl[IDS_DLL_LOADFAIL] = "Failed to load Engine DLL.";
	m_reslbl[IDS_CMDLINE_VTOPTS] = "-vt requires one of software, gl, or d3d.";
	m_reslbl[IDS_SAVE_NUMCHANGED] = "Number of saved games changed?";
	m_reslbl[IDS_BINDINGS_ALLOCFAIL] = "Unable to allocate space for binding";
	m_reslbl[IDS_GAMMA_LOADFAIL] = "Unable to locate the gamma image 'gamma.bmp'.";
	m_reslbl[IDS_DDRAW_RESTOREMODEFAIL] = "Unable to restore DirectDraw video mode.";
	m_reslbl[IDS_AUDIO_VOLUME] = "Game sound volume";
	m_reslbl[IDS_AUDIO_SUITVOL] = "HEV suit volume";
	m_reslbl[IDS_AUDIO_USECD] = "Play CD music.";
	m_reslbl[IDS_AUDIO_HIGHQUALITY] = "High quality sound";
	m_reslbl[IDS_CFG_VIDHELP] = "Change screen size, video mode, gamma, and glare reduction.";
	m_reslbl[IDS_CFG_AUDIOHELP] = "Change sound volume and quality.";
	m_reslbl[IDS_CFG_CONTROLHELP] = "Change keyboard, mouse, and joystick settings.";
	m_reslbl[IDS_CFG_RETURNTOMAIN] = "Go back to the Main Menu.";
	m_reslbl[IDS_CREATEROOM_TITLE] = "Create Private Room";
	m_reslbl[IDS_CREATEROOM_ROOMNAME] = "Room Name";
	m_reslbl[IDS_CREATEROOM_ROOMTOPIC] = "Room Topic";
	m_reslbl[IDS_CREATESERVER_NAME] = "Server Name:";
	m_reslbl[IDS_CREATESERVER_MAP] = "Map:";
	m_reslbl[IDS_CREATESERVER_ROOM] = "Associated Room:";
	m_reslbl[IDS_CREATESERVER_GAMETYPE] = "Type of Game:";
	m_reslbl[IDS_CREATESERVER_MAXPLAYERS] = "Max. Players:";
	m_reslbl[IDS_FILTER_TITLE] = "Filter the list of Half-Life games";
	m_reslbl[IDS_FILTER_HEADING] = "Show only servers which:";
	m_reslbl[IDS_FILTER_RESPONDING] = "are responding";
	m_reslbl[IDS_FILTER_RESPONSETIME] = "responded more quickly than";
	m_reslbl[IDS_FILTER_NOTFULL] = "are not full";
	m_reslbl[IDS_FILTER_NOTEMPTY] = "have people currently playing";
	m_reslbl[IDS_FILTER_ONFAVORITES] = "are in my 'favorites' list";
	m_reslbl[IDS_FILTER_INCHATROOM] = "are associated with the selected chat room";
	m_reslbl[IDS_FINDPLAYER_PLAYER] = "Player to find:";
	m_reslbl[IDS_OPTS_CROSSHAIR] = "Crosshair";
	m_reslbl[IDS_OPTS_REVERSE] = "Reverse mouse";
	m_reslbl[IDS_OPTS_MLOOK] = "Mouse look";
	m_reslbl[IDS_OPTS_LOOKSPRING] = "Look spring";
	m_reslbl[IDS_OPTS_LOOKSTRAFE] = "Look strafe";
	m_reslbl[IDS_OPTS_MFILTER] = "Mouse filter";
	m_reslbl[IDS_OPTS_JOYSTICK] = "Joystick";
	m_reslbl[IDS_OPTS_CROSSHAIRHELP] = "Enable the weapon aiming crosshair.";
	m_reslbl[IDS_OPTS_REVERSEHELP] = "Reverse mouse up/down axis.";
	m_reslbl[IDS_OPTS_MLOOKHELP] = "Use the mouse to look around instead of using the mouse to move.";
    //m_reslbl[IDS_OPTS_LOOKSPRINGHELP] = "Causes the screen to] = "";spring";"; back to looking straight ahead when you move forward.";
	m_reslbl[IDS_OPTS_LOOKSTRAFEHELP] = "In combination with your mouse look modifier, causes left-right movements to strafe instead of turn.";
	m_reslbl[IDS_OPTS_MFILTERHELP] = "Average mouse inputs over the last two frames to smooth out movements.";
	m_reslbl[IDS_OPTS_JOYSTICKHELP] = "Enable the joystick.";
	m_reslbl[IDS_OPTS_SENSITIVITYHELP] = "Mouse sensitivity.";
	m_reslbl[IDS_LOADSAVE_LOADHELP] = "Load a previously saved game";
	m_reslbl[IDS_LOADSAVE_SAVEHELP] = "Save current game.";
	m_reslbl[IDS_LOADSAVE_RETURN] = "Go back to the Main Menu.";
	m_reslbl[IDS_MAIN_RETURNHELP] = "Return to game.";
	m_reslbl[IDS_MAIN_NEWGAMEHELP] = "Start a new game.";
	m_reslbl[IDS_MAIN_TRAININGHELP] = sprintf("Learn how to play %s.", games[gameinfo_current].game);
	m_reslbl[IDS_MAIN_LOADHELP] = "Load a previously saved game.";
	m_reslbl[IDS_MAIN_LOADSAVEHELP] = "Load a saved game, save the current game.";
	m_reslbl[IDS_MAIN_CONFIGUREHELP] = "Change game settings, configure controls.";
	m_reslbl[IDS_MAIN_READMEHELP] = "View the Readme.txt file.";
	m_reslbl[IDS_MAIN_ORDERHELP] = "Order the full version of Half-Life.";
	m_reslbl[IDS_MAIN_QUITHELP] = sprintf("Quit playing %s.", games[gameinfo_current].game);
	m_reslbl[IDS_MAIN_QUICKHELP] = "Connect to the fastest, active Internet game server found.";
	m_reslbl[IDS_MAIN_MULTIPLAYERHELP] = sprintf("Search for %s servers, chat with other players, configure character.", games[gameinfo_current].game);
	m_reslbl[IDS_CHAT_PROMPT] = "Type Message:";
	m_reslbl[IDS_NEWGAME_EASYHELP] = sprintf("Play %s on the 'easy' skill setting.", games[gameinfo_current].game);
	m_reslbl[IDS_NEWGAME_MEDIUMHELP] = sprintf("Play %s on the 'medium' skill setting.", games[gameinfo_current].game);
	m_reslbl[IDS_NEWGAME_DIFFICULTHELP] = sprintf("Play %s on the 'difficult' skill setting.", games[gameinfo_current].game);
	m_reslbl[IDS_NEWGAME_RETURNHELP] = "Go back to the Main Menu.";
	m_reslbl[IDS_NEWPROFILE_TITLE] = "Select Player";
	m_reslbl[IDS_NEWPROFILE_NAME] = "Na&me:";
	m_reslbl[IDS_NEWPROFILE_PASSWORD] = "Password:";
	m_reslbl[IDS_NEWPROFILE_REMEMBER] = "remember password";
	m_reslbl[IDS_PROFILE_MODEL] = "Player Model";
	m_reslbl[IDS_PROFILE_NICKNAME] = "Player Name";
	m_reslbl[IDS_PROFILE_SELECT] = "Player profile:";
	m_reslbl[IDS_PROFILE_PROCEEDHELP] = "Chat with users and browse for servers.";
	m_reslbl[IDS_PROFILE_RETURNHELP] = "Go back to the Main Menu.";
	m_reslbl[IDS_VIDEO_SCREENSIZE] = "Screen size";
	m_reslbl[IDS_VIDEO_GAMMA] = "Gamma";
	m_reslbl[IDS_VIDEO_GLARE] = "Glare reduction";
	m_reslbl[IDS_VIDEO_GAMMAHELP] = "Gamma:  Adjusts Half-Life's color balance to best suit your monitor. Move the slider until you can just make out the figure standing in shadow on the right side of the sample image.";
	m_reslbl[IDS_VIDEO_GLAREHELP] = "Glare Reduction: Adjusts darker colors to reduce the effect of glare on your monitor.";
	m_reslbl[IDS_VIDMODE_WINDOWED] = "Run in a &window";
	m_reslbl[IDS_VIDMODE_MOUSE] = "&Use mouse";
	m_reslbl[IDS_VIDMODE_GLLISTHEADER] = "OpenGL Driver";
	m_reslbl[IDS_VIDMODE_D3DHEADER] = "D3D Device";
	m_reslbl[IDS_VIDSELECT_OPTIONSHELP] = "Set video options such as screen size, gamma, and glare reduction.";
	m_reslbl[IDS_VIDSELECT_MODESHELP] = "Set video modes and configure 3D accelerators.";
	m_reslbl[IDS_VIDSELECT_RETURNHELP] = "Go back to the previous menu.";
	m_reslbl[IDS_SERVERS_REFRESH] = "Refreshing servers...";
	m_reslbl[IDS_PROGRESS_START] = "Start";
	m_reslbl[IDS_QUICK_CONTACT] = "Contacting servers...";
	m_reslbl[IDS_QUICK_REQUESTLIST] = "Requesting list of servers...";
	m_reslbl[IDS_README_NOFILE] = "Could not find readme.txt";
	m_reslbl[IDS_STATUS_CONNECTING] = "Connecting to server '%s'";
	m_reslbl[IDS_STATUS_CONNECTIONESTABLISHED] = "Connection established to %s, switching to game";
	m_reslbl[IDS_STATUS_SKIPSERVER] = "Skipping...";
	m_reslbl[IDS_STATUS_ELPASEDTIME] = "%s\n%3.1f Seconds Elapsed";
	m_reslbl[IDS_TRAINING_EXITCURRENT] = "Entering the Hazard Course will exit any current game, OK to exit?";
	m_reslbl[IDS_MAIN_QUITPROMPTINGAME] = sprintf("Quit %s without saving current game?", games[gameinfo_current].game);
	m_reslbl[IDS_MAIN_QUITPROMPT] = "Are you sure you want to quit?";
	m_reslbl[IDS_CONTROLS_CANCELPROMPT] = "Exit without saving changes?";
	m_reslbl[IDS_LOAD_LOADPROMPT] = "Loading a game will exit any current game, OK to exit?";
	m_reslbl[IDS_LOADSAVE_DELETEPROMPT] = "Delete selected game?";
	m_reslbl[IDS_NEWGAME_NEWPROMPT] = "Starting a new game will exit any current game, OK to exit?";
	m_reslbl[IDS_NICKNAME_ADD] = "Enter a name:";
	m_reslbl[IDS_PROFILE_CANCELPROMPT] = "Save changes made to profile?";
	m_reslbl[IDS_SAVE_INGAMEPROMPT] = "Can't save, you are not currently playing a game.";
	m_reslbl[IDS_SAVE_OVERWRITE] = "Are you sure you want to overwrite this saved game?";
	m_reslbl[IDS_VIDEO_BADSETTINGS] = "Your video settings do not appear to be valid, use these settings anyway?";
	m_reslbl[IDS_AUDIO_A3D] = "Enable A3D hardware support";
	m_reslbl[IDS_BTN_DONE] = "&Done";
	m_reslbl[IDS_BTN_CONTROLS] = "&Controls";
	m_reslbl[IDS_BTN_AUDIO] = "&Audio";
	m_reslbl[IDS_BTN_VIDEO] = "&Video";
	m_reslbl[IDS_BTN_CANCEL] = "&Cancel";
	m_reslbl[IDS_BTN_CREATE] = "Create &room";
	m_reslbl[IDS_BTN_FILTER] = "&Filter";
	m_reslbl[IDS_BTN_FIND] = "&Search";
	m_reslbl[IDS_BTN_RETURN] = "&Return";
	m_reslbl[IDS_BTN_NEWGAME] = "&New game";
	m_reslbl[IDS_BTN_TRAINING] = "&Hazard course";
	m_reslbl[IDS_BTN_CONFIGURE] = "&Configure";
	m_reslbl[IDS_BTN_LOADSAVE] = "&Save/load game";
	m_reslbl[IDS_BTN_LOAD] = "&Load game";
	m_reslbl[IDS_BTN_MULTIPLAYER] = "&Multiplayer";
	m_reslbl[IDS_BTN_README] = "&View readme";
	m_reslbl[IDS_BTN_ORDER] = "&Order";
	m_reslbl[IDS_BTN_QUIT] = "&Quit";
	m_reslbl[IDS_BTN_ADVANCED] = "&Advanced controls";
	m_reslbl[IDS_BTN_REVERT] = "&Cancel";
	m_reslbl[IDS_BTN_RESTORE] = "&Use defaults";
	m_reslbl[IDS_BTN_DELETE] = "&Delete";
	m_reslbl[IDS_BTN_SAVE] = "&Save game";
	m_reslbl[IDS_BTN_LOGIN] = "&Login";
	m_reslbl[IDS_BTN_CONNECT] = "&Connect";
	m_reslbl[IDS_BTN_CREATESV] = "Crea&te game";
	m_reslbl[IDS_BTN_REFRESH] = "&Refresh";
	m_reslbl[IDS_BTN_ROOM] = "&List rooms";
	m_reslbl[IDS_BTN_EASY] = "&Easy";
	m_reslbl[IDS_BTN_MEDIUM] = "&Medium";
	m_reslbl[IDS_BTN_HARD] = "&Difficult";
	m_reslbl[IDS_BTN_YES] = "&Yes";
	m_reslbl[IDS_BTN_NO] = "&No";
	m_reslbl[IDS_BTN_OK] = "&Ok";
	m_reslbl[IDS_BTN_OPTIONS] = "&Video options";
	m_reslbl[IDS_BTN_MODES] = "Video &modes";
	m_reslbl[IDS_BTN_QUICK] = "&Quick start";
	m_reslbl[IDS_PROFILE_LOGO] = "Spraypaint Image";
	m_reslbl[IDS_BTN_BROWSE] = "&Internet games";
	m_reslbl[IDS_MULTI_BROWSEHELP] = sprintf("View a list of %s game servers and join the one of your choice.", games[gameinfo_current].game);
	m_reslbl[IDS_BTN_CHAT] = "C&hat rooms";
	m_reslbl[IDS_MULTI_CHATHELP] = sprintf("Talk online with other %s players.", games[gameinfo_current].game);
	m_reslbl[IDS_BTN_LAN] = "&Lan game";
	m_reslbl[IDS_MULTI_LANHELP] = sprintf("Set up a %s game on a local area network.", games[gameinfo_current].game);
	m_reslbl[IDS_BTN_CUSTOMIZE] = "C&ustomize";
	m_reslbl[IDS_MULTI_CUSTOMIZEHELP] = "Choose your player name, and select visual options for your character.";
	m_reslbl[IDS_CREATEROOM_ROOMPASSWORD] = "Room Password (optional)";
	m_reslbl[IDS_PLAYERINFO_RULENAME] = "Server Rule";
	m_reslbl[IDS_PLAYERINFO_RULEVALUE] = "Value";
	m_reslbl[IDS_BTN_SEARCH] = "&Search for Game";
	m_reslbl[IDS_BTN_CHATMODE] = "Chat";
	m_reslbl[IDS_BTN_LISTMODE] = "&Internet games";
	m_reslbl[IDS_BTN_EXIT] = "&Exit";
	m_reslbl[IDS_SERVER_MANUALADD] = "Add a server by manually by IP address...";
	m_reslbl[IDS_SERVER_REQUESTNEWLIST] = "Request updated server list.";
	m_reslbl[IDS_PLAYERINFO_SERVERNAME] = "Server hostname:";
	m_reslbl[IDS_PLAYERINFO_SERVERIP] = "Server IP address:";
	m_reslbl[IDS_PLAYERINFO_SERVERPING] = "Server 'ping' time:";
	m_reslbl[IDS_PROFILE_FACE] = "Player Face";
	m_reslbl[IDS_PROFILE_SKIN] = "Player Skin";
	m_reslbl[IDS_BTN_JOIN] = "&Join Game";
	m_reslbl[IDS_BTN_FINDGAME] = "&Find Game";
	m_reslbl[IDS_BTN_START] = "S&tart Game";
	m_reslbl[IDS_PROFILE_LOGOCOLOR] = "Color";
	m_reslbl[IDS_MULTI_RESUMEHELP] = "Return to your current muli-player game.";
	m_reslbl[IDS_MULTI_DISCONNECTHELP] = "Disconnect yourself from the game server.";
	m_reslbl[IDS_BTN_RESUME] = "Resume";
	m_reslbl[IDS_BTN_DISCONNECT] = "Disconnect";
	m_reslbl[IDS_BTN_ADDSERVER] = "&Add server";
	m_reslbl[IDS_BTN_UPDATE] = "&Update";
	m_reslbl[IDS_BTN_INFO] = "&View game info";
	m_reslbl[IDS_QUICKSTART_TITLE] = "Quick multiplayer";
	m_reslbl[IDS_BTN_LISTROOMS] = "&List rooms";
	m_reslbl[IDS_BTN_GORE] = "C&ontent control";
	m_reslbl[IDS_BTN_AUTOPATCH] = "&Update Half-Life.";
	m_reslbl[IDS_CONFIGURE_GOREHELP] = "Disable visuals inappropriate for younger players and multiplayer.";
	m_reslbl[IDS_CONFIGURE_AUTOPATCHHELP] = "Download the latest version of Half-Life.";
	m_reslbl[IDS_CHAT_NOSERVERS] = "Could not locate any Frag-Net servers.";
	m_reslbl[IDS_CHAT_NOPROFILE] = "Couldn't locate player profile";
	m_reslbl[IDS_INIT_DX6REQUIRED] = "Half-Life requires DirectX version 6 or above.   Please install DirectX 6 and restart Half-Life.";
	m_reslbl[IDS_WON_VALIDATIONFAIL] = "Validation refused\n'%s'";
	m_reslbl[IDS_WON_VALIDATIONFAIL2] = "Validation refused.";
	m_reslbl[IDS_WON_AUTHOUTOFORDER] = "Authentication out of order (1).";
	m_reslbl[IDS_WON_AUTHPROBLEM] = "Authentication problem (2)";
	m_reslbl[IDS_WON_ENCRYPTBAD] = "Error creating message (1).";
	m_reslbl[IDS_WON_BADPUBLICKEY] = "Invalid signal from authentication server (1).";
	m_reslbl[IDS_WON_AUTHNOMEM] = "Insufficient memory to receive authentication response.";
	m_reslbl[IDS_CD_NEEDCDKEY] = "You must type in a valid CD Key to play Half-Life";
	m_reslbl[IDS_CD_BADKEY] = "The CD Key you typed was invalid, please try again";
	m_reslbl[IDS_CD_BADKEYTYPED] = "Your CD Key is invalid, please reenter the CD key";
	m_reslbl[IDS_MD5_HASHFAIL] = "Could not validate Half-Life";
	m_reslbl[IDS_MAIN_REGISTERMSGFAIL] = "Couldn't register Half-Life user message";
	m_reslbl[IDS_CDCHECK_PROMPT] = "Please Insert the Half-Life CD";
	m_reslbl[IDS_SETTINGS_SERVERTYPEINVALID] = "Bogus list type in %s";
	m_reslbl[IDS_TOKEN_EXPECTLEFTBRACE] = "Expecting { in %s";
	m_reslbl[IDS_TOKEN_EXPECTRIGHTBRACE] = "Expecting } in %s";
	m_reslbl[IDS_MULTI_ADDIPUNRESOLVABLE] = "That IP address could not be resolved.";
	m_reslbl[IDS_CHATCTRL_NOMEM] = "Couldn't allocate space for user name";
	m_reslbl[IDS_CHATCTRL_NOTEXTMEM] = "Couldn't allocate space for chat text";
	m_reslbl[IDS_CHATCTRL_WINREGFAIL] = "Couldn't register chat edit control";
	m_reslbl[IDS_PROFILE_DEFAULTMISSING] = "Could not find default keybinding file %s";
	m_reslbl[IDS_QUICK_NOMASTER] = "Unable to retrieve server list, check that your internet connection is active";
	m_reslbl[IDS_QUICK_USINGPREVIOUSLIST] = "Unable to reach master, using previous list...";
	m_reslbl[IDS_CHAT_NOROOMLIST] = "Could not obtain room list";
	m_reslbl[IDS_SAVELOAD_NUMBEROFGAMESCHANGED] = "Number of saved games changed?";
	m_reslbl[IDS_MAIN_EXITMULTIPLAYERPROMPT] = "Entering the multiplayer system will terminate your current single player game, OK to exit without saving?";
	m_reslbl[IDS_CD_ENTERPROMPT] = "Please type in the CD Key displayed on the Half-Life CD case";
	m_reslbl[IDS_MULTISELECT_EXITGAMEPROMPT] = "Exiting the multiplayer system will terminate your current multiplayer game, OK to exit?";
	m_reslbl[IDS_MULTI_ADDSERVERPROMPT] = "Enter server Internet address\r\n(e.g., 209.255.10.255:27015)";
	m_reslbl[IDS_ROOM_NEEDPASS] = "Enter room password:";
	m_reslbl[IDS_SAVE_CANTSAVE] = "Can't save, you are not currently playing a game.";
	m_reslbl[IDS_SAVE_OVERWRITEPROMPT] = "Are you sure you want to overwrite this saved game?";
	m_reslbl[IDS_SAVE_DELETEPROMPT] = "Delete selected game?";
	m_reslbl[IDS_AUTH_INUSE] = "Account in use";
	m_reslbl[IDS_AUTH_BADACCOUNT] = "Invalid account";
	m_reslbl[IDS_AUTH_BADREQ] = "Invalid server request";
	m_reslbl[IDS_AUTH_BADCERTIFICATE] = "Invalid client certificate";
	m_reslbl[IDS_AUTH_BADEXE] = "Invalid client value";
	m_reslbl[IDS_AUTH_BADCERTIFICATE2] = "Invalid client certificate";
	m_reslbl[IDS_AUTH_BADLOOKUP] = "Invalid client lookup value";
	m_reslbl[IDS_AUTH_BADBITS] = "Invalid client authentication value";
	m_reslbl[IDS_AUTH_CORRUPT] = "Corrupt executable";
	m_reslbl[IDS_AUTH_INVALIDACCOUNT] = "Unknown account error";
	m_reslbl[IDS_CHAT_STATUSUNCONNECTED] = "Unconnected.";
	m_reslbl[IDS_CHAT_WONCONNECT] = "Attempting connection...";
	m_reslbl[IDS_CHAT_USERENTER] = "%s entered...\r\n";
	m_reslbl[IDS_CHAT_USERLEFT] = "%s left...\r\n";
	m_reslbl[IDS_ENG_STARTING] = "Starting engine...";
	m_reslbl[IDS_SERVERS_SEARCHING] = "Searching for servers...";
	m_reslbl[IDS_SERVERS_LISTREC] = "Got Server List...";
	m_reslbl[IDS_SERVERS_CONNECTING] = "Connecting to servers...";
	m_reslbl[IDS_SERVERS_REQUESTINFO] = "Requesting server information";
	m_reslbl[IDS_ROOM_CREATENOTICE] = "Creating room '%s', please wait";
	m_reslbl[IDS_ROOM_CREATEPROMPTTITLE] = "Creating room";
	m_reslbl[IDS_SAVE_TIMEHEADING] = "Time";
	m_reslbl[IDS_SAVE_GAMEHEADING] = "Game";
	m_reslbl[IDS_SAVE_ELAPSEDHEADING] = "Elapsed Time";
	m_reslbl[IDS_SAVE_NEWCAPTION] = "New Saved Game";
	m_reslbl[IDS_SAVE_NEWGAMETXT] = "New";
	m_reslbl[IDS_SAVE_FILETIME] = "Current";
	m_reslbl[IDS_STATUS_CONNECTINGNOTIME] = "Connecting to server '%s'...\n\n%s";
	m_reslbl[IDS_MULTI_CHATROOMCAPTION] = "Room:";
	m_reslbl[IDS_GORE_CHECKBOX] = "Activate content control";
	m_reslbl[IDS_GORE_HELP] = "Check this box and enter password to disable visuals inappropriate for younger players and multiplayer.  Anyone wishing to change this setting will need to use this password.";
	m_reslbl[IDS_GORE_PWPROMPT1] = "Enter password:";
	m_reslbl[IDS_GORE_PWPROMPT2] = "Enter again to confirm:";
	m_reslbl[IDS_GORE_PWMISMATCHED] = "The passwords you entered did not match, please try again.";
	m_reslbl[IDS_GORE_BADPW] = "Incorrect password";
	m_reslbl[IDS_BTN_ADVANCEDSVR] = "&Advanced options";
	m_reslbl[IDS_OPTS_AUTOAIM] = "Autoaim";
	m_reslbl[IDS_OPTS_AUTOAIMHELP] = "Allow Half-Life to help you aim at enemies.";
	m_reslbl[IDS_BTN_PREVIEWS] = "&Previews";
	m_reslbl[IDS_MAIN_PREVIEWSHELP] = "Find out more about Valve's product lineup.";
	m_reslbl[IDS_SECONDS_LEFT] = "%i seconds left...";
	m_reslbl[IDS_MEDIA_PREVIEWURL] = "http://www.valvesoftware.com/projects.htm";
	m_reslbl[IDS_ADVANCEDSVR_PAGE] = "Page %i of %i";
	m_reslbl[IDS_EMPTY] = "";
	m_reslbl[IDS_MULTI_TYPE] = "Internet Connection Speed";
	m_reslbl[IDS_MULTI_LAN] = "LAN - T1 > 1M";
	m_reslbl[IDS_MULTI_ISDN] = "ISDN - 112K";
	m_reslbl[IDS_MODEM56K] = "Modem - 56K";
	m_reslbl[IDS_MODEM28K] = "Modem - 28.8K";
	m_reslbl[IDS_OPTS_HIMODELS] = "&High quality models (for fast computers)";
	m_reslbl[IDS_OPTS_HIMODELSHELP] = "";
	m_reslbl[IDS_CHAT_SOCKETERROR] = "Chat connection problem, retrying connection...";
	m_reslbl[IDS_CHAT_RECONNECTFAIL] = "Reconnection to chat failed, please verify that you are connected to the internet and try again.";
	m_reslbl[IDS_CHAT_RECONNECTSUCCESS] = "Reconnected...";
	m_reslbl[IDS_CHAT_JOINFAILED] = "Could not join room '%s'.  Click 'List rooms' to select a different room.";
	m_reslbl[IDS_BTN_WON] = "Visit &FRAG-NET.COM";
	m_reslbl[IDS_WON_URL] = "www.frag-net.com";
	m_reslbl[IDS_AUDIO_CDHINT] = "Set CD volume with the Windows multimedia accessory for volume control.";
	m_reslbl[IDS_PREVIOUS] = "Previous";
	m_reslbl[IDS_NEXT] = "Next";
	m_reslbl[IDS_MODEM33K] = "Modem - 33.6K";
	m_reslbl[IDS_MODEM14K] = "Modem - 14.4K";
	m_reslbl[IDS_ROOM_PERMANENT] = "Permanent rooms";
	m_reslbl[IDS_ROOM_USER] = "User-created rooms";
	m_reslbl[IDS_MULTI_DONEHELP] = "Go back to the Main Menu.";
	m_reslbl[IDS_MULTI_WONHELP] = "Go to the Frag-Net.";
	m_reslbl[IDS_AUDIO_EAX] = "Enable EAX hardware support";
	m_reslbl[IDS_GL_NOMODE] = "The selected OpenGL mode is not supported by your video card.";
	m_reslbl[IDS_D3D_NOMODE] = "The selected D3D mode is not supported by your video card.";
	m_reslbl[IDS_VID_NOMODE] = "The selected video mode is not available.";
	m_reslbl[IDS_VID_RESELECT] = "Please select a different video mode.";
	m_reslbl[IDS_VID_INITFAIL] = "The video subsystem could not be initialized.";
	m_reslbl[IDS_NET_WONCONNFAIL] = "Could not connect to the Frag-Net server.  Please check your internet connection.";
	m_reslbl[IDS_NET_CORRUPT] = "Your Half-Life executable is out of date.  Half-Life will now update to the current version.";
	m_reslbl[IDS_CDKEY_BAD] = "Your Half-Life CD Key is invalid.";
	m_reslbl[IDS_MULTI_REFRESH] = "Requesting server information";
	m_reslbl[IDS_CHAT_NOROOM] = "Not connected";
	m_reslbl[IDS_RUN_PATCH] = "Check the Internet for updates?";
	m_reslbl[IDS_WON_AUTHFAILURE] = "Unable to authenticate with Frag-Net servers.";
	m_reslbl[IDS_WON_LOGIN] = "Logging on to Frag-Net";
	m_reslbl[IDS_LOGO_SIZEMISMATCH] = "Custom logos must have the same width and height.";
	m_reslbl[IDS_LOGO_OVERSIZED] = "Custom logos can be no larger than 64 x 64 pixels.";
	m_reslbl[IDS_LOGO_POWEROF2] = "Custom logo width and height must be 2, 4, 8, 16, 32, ro 64.";
	m_reslbl[IDS_MODEM_CUSTOM] = "Custom";
	m_reslbl[IDS_MODEM_RATE] = "Enter data transfer rate (100 - 9999)";
	m_reslbl[IDS_REGISTRY_UPDATE] = "Updating registry settings for Half-Life.  You will need to reconfigure your settings.";
	m_reslbl[IDS_CHAT_JOIN] = "Tyring to join %s";
	m_reslbl[IDS_CHAT_FLOOD] = "Too much text, please wait.";
	m_reslbl[IDS_CHAT_SEARCH] = "Searching for user %s...";
	m_reslbl[IDS_CHAT_NOINFO] = "Directory server did not return any user information.";
	m_reslbl[IDS_CHAT_NOFIND] = "Couldn't find user %s";
	m_reslbl[IDS_CHAT_FIND] = "Found %s in %s";
	m_reslbl[IDS_CHAT_NOAUTH] = "Could not obtain authentication information";
	m_reslbl[IDS_CHAT_NODIR] = "Server did not return any directory information.";
	m_reslbl[IDS_CHAT_NOSUCHROOM] = "Could not find room %s";
	m_reslbl[IDS_CHAT_ROOMFULL] = "Can't join %s..., room has too many users (%i), try again later";
	m_reslbl[IDS_CREATESV_NOADVANCED] = "No advanced options available";
	m_reslbl[IDS_WON_CDINUSE] = "Your Half-Life CD Key is currently in use.  Please try again later.";
	m_reslbl[IDS_CHAT_JOINHINT] = "Type /join [roomname] to join another chat room.";
	m_reslbl[IDS_WON_BANNED] = "Your CD key cannot be used on the Frag-Net system.";
	m_reslbl[IDS_CONTENT_NOMULTIPLAYER] = "Content control configuration - on";
	m_reslbl[IDS_PATCH_ERROR] = "Half-Life AutoPatch Error";
	m_reslbl[IDS_PATCH_NOUTIL] = "Sierra Utilites are not properly installed. Please reinstall from the CD.";
	m_reslbl[IDS_PATCH_FAIL] = "Could Not Run the AutoPatch Program";
	m_reslbl[IDS_PATCH_BADINSTALL] = "Half-Life is not properly Installed";
	m_reslbl[IDS_CONNECT_FAILURE] = "Could not connect to game server\r\nReason:  %s";
	m_reslbl[IDS_MULTI_NEEDPASSWORD] = "Password required, please enter a password to try connecting again.";
	m_reslbl[IDS_VID_HINT] = "640 x 480 is recommended as the most reliable OpenGL mode.  Other modes are hardware dependent and may not be available on your card.\n\nIf you have a 3D card that incorporates the Voodoo, Voodoo 2, or Banshee chipsets, select the 3DFX Mini Driver as your OpenGL Driver.";
	m_reslbl[IDS_MULTI_LOGODISCONNECT] = "Changing your logo will terminate your current multiplayer game, OK to exit?";
	m_reslbl[IDS_3D_WARNING] = "For 3D support, Half-Life requires the current versions of device drivers on your system. The 3D Info link will help you ensure you have the correct drivers.";
	m_reslbl[IDS_3DSITE_URL] = "www.sierrastudios.com/games/half-life/support/3Dinfo/";
	m_reslbl[IDS_WON_MODIFIED] = "Your Half-Life executable has been modified.  Please check your system for viruses and then re-install Half-Life.";
	m_reslbl[IDS_ADVANCEDMP_OFFSETS] = "0";
	m_reslbl[IDS_AUDIO_OFFSET] = "0 0 0 0";
	m_reslbl[IDS_CONFIGURE_OFFSET] = "0 0";
	m_reslbl[IDS_CREATEROOM_OFFSET] = "0";
	m_reslbl[IDS_CREATESERVER_OFFSET] = "0";
	m_reslbl[IDS_GAMEOPTIONS_OFFSET] = "0 0 0 0";
	m_reslbl[IDS_HLMAIN_OFFSET] = "0";
	m_reslbl[IDS_KEYBOARD_OFFSET] = "0";
	m_reslbl[IDS_LAN_OFFSET] = "110 50 75 80 70";
	m_reslbl[IDS_LOAD_OFFSET] = "0 0";
	m_reslbl[IDS_NETGAMEDLG_OFFSET] = "0 0 0";
	m_reslbl[IDS_NEWGAMEDLG_OFFSET] = "0";
	m_reslbl[IDS_PLAYERINFODLG_OFFSET] = "0";
	m_reslbl[IDS_PLAYERPROFILEDLG_OFFSET] = "0 0";
	m_reslbl[IDS_PROMPT_OFFSET] = "0 0";
	m_reslbl[IDS_ROOM_OFFSET] = "0";
	m_reslbl[IDS_VIDEODLG_OFFSET] = "0";
	m_reslbl[IDS_VIDEOMODEDLG_OFFSET] = "0 0";
	m_reslbl[IDS_VIDSELECTDLG_OFFSET] = "0 0";
	m_reslbl[IDS_UPDATERREGISTRYINSTALLDIR] = "HALFLIFE";
	m_reslbl[IDS_SPANISH] = "0";
	m_reslbl[IDS_FRENCH] = "0";
	m_reslbl[IDS_OPTS_JLOOKHELP] = "Use the joystick to look around instead of using the joystick to move.";
	m_reslbl[IDS_OPTS_JLOOK] = "Joystick look";
	m_reslbl[IDS_GERMAN] = "0";
	m_reslbl[IDS_CONNECT_PROTOCOLBAD] = "You cannot connect to a server which is operating under a different protocol version.";
	m_reslbl[IDS_SERVER_MENU_QUICK] = "Sort list using best server estimate";
	m_reslbl[IDS_DECAL_LIMIT] = "Maximum number of decals in multiplayer.";
	m_reslbl[IDS_SPRITE_SKIP] = "Draw faster software sprites";
	m_reslbl[IDS_MODEL_NAME] = "Player Model:  %s";
	m_reslbl[IDS_FILTER_BYGAME] = "are running game ";
	m_reslbl[IDS_BTN_SETINFO] = "&Advanced options";
	m_reslbl[IDS_MODLIST_TYPE] = "Type";
	m_reslbl[IDS_MODLIST_NAME] = "Name";
	m_reslbl[IDS_MODLIST_VERSION] = "Version";
	m_reslbl[IDS_MODLIST_SIZE] = "Size";
	m_reslbl[IDS_MODLIST_RATING] = "Rating";
	m_reslbl[IDS_MODLIST_INSTALLED] = "Installed";
	m_reslbl[IDS_MODLIST_SERVERS] = "Servers";
	m_reslbl[IDS_MODLIST_PLAYERS] = "Players";
	m_reslbl[IDS_MOD_DOWNLOADING] = "Downloading '%s'";
	m_reslbl[IDS_MOD_DLSIZEMB] = "Total download size for game %s\r\n%.2fmb";
	m_reslbl[IDS_MOD_DLSIZEKB] = "Total download size for game %s\r\n%.0fkb";
	m_reslbl[IDS_MOD_DLSTATUS] = "Downloading %s from\r\n%s\r\nFile:  %s\r\n%.0f%%";
	m_reslbl[IDS_MOD_TIME] = "%.1f seconds";
	m_reslbl[IDS_MOD_CONNECT] = "Connecting to %s";
	m_reslbl[IDS_MOD_GETTINGSIZE] = "Getting download size";
	m_reslbl[IDS_MOD_DLSTATUSSHORT] = "Downloading %s from\r\n%s";
	m_reslbl[IDS_MOD_NOFILES] = "Nothing to download";
	m_reslbl[IDS_MOD_NOLIBLIST] = "Could not find liblist.gam file on remote host\r\nDouble check that %s is a valid custom game site";
	m_reslbl[IDS_INTERNET_CURRENTTOTALS] = "%i servers (%i players online)";
	m_reslbl[IDS_SERVER_REFRESH] = "Refresh selected server";
	m_reslbl[IDS_CONNECT_NEEDMOD] = "You cannot connect to a server running custom game %s until you install the custom game";
	m_reslbl[IDS_MOD_REMOTEOPENFAIL] = "Could not open %s on remote machine";
	m_reslbl[IDS_MOD_LOCALOPENFAIL] = "Could not open %s on local machine";
	m_reslbl[IDS_BTN_CUSTOMGAME] = "C&ustom game";
	m_reslbl[IDS_MAIN_CUSTOMHELP] = "Select a custom game, search the Internet for custom games";
	m_reslbl[IDS_BTN_ACTIVATE] = "&Activate";
	m_reslbl[IDS_BTN_INSTALL] = "&Install";
	m_reslbl[IDS_BTN_DETAILS] = "Details";
	m_reslbl[IDS_BTN_VISIT] = "&Visit web site";
	m_reslbl[IDS_BTN_REFRESHMODS] = "&Refresh list";
	m_reslbl[IDS_BTN_DEACTIVATE] = "D&eactivate";
	m_reslbl[IDS_MOD_INFO] = "Info:";
	m_reslbl[IDS_YES] = "Yes";
	m_reslbl[IDS_NO] = "No";
	m_reslbl[IDS_UPDATE] = "Update";
	m_reslbl[IDS_MODREQ_TITLE] = "Requesting custom game info";
	m_reslbl[IDS_DOWNLOAD_WARNING] = "You are about to download a custom game.  Downloading a custom game for Half-Life has the same issues and risks as downloading any program from the Internet.  They could contain viruses, have bugs that will crash your system causing you to lose unsaved work, or could perform operations that might harm your computer.\r\nYou can disable this warning by checking the \"Don't show this warning again\" checkbox at the bottom of this form.";
	m_reslbl[IDS_WARN_CHECKPROMPT] = "Don't show this warning again";
	m_reslbl[IDS_MOD_VERSION] = "Custom game '%s' has a new version available, are you sure you want to select it before installing the updated version?";
	m_reslbl[IDS_MOD_REINSTALL] = "Custom game %s is already installed, are you sure you want to re-install?";
	m_reslbl[IDS_WARN_TITLE] = "Custom game download";
	m_reslbl[IDS_MOD_ENGINEVERSION] = "Custom game '%s' was created for a different version of Half-Life than the current version you have installed.  Are you sure you want to select it before installing the updated version?";
	m_reslbl[IDS_MOD_CONNVERSION] = "You cannot connect to a server running version %i of custom game '%s' until you upgrade to that version.  Your current version is %i";
	m_reslbl[IDS_CONNHLVERSION] = "You are attempting to connect to a server running game '%s' for Half-Life version %s.  Your current version of Half-Life is %s.  Continue anyway?";
	m_reslbl[IDS_MOD_NOTINSTALLED] = "Can't activate custom game '%s', you must install the custom game first.";
	m_reslbl[IDS_REFRESH_SERVERS] = "%i servers remaining";
	m_reslbl[IDS_DEDICATED] = "Dedicated server (faster, but you can't join the server from this machine).";
	m_reslbl[IDS_MOD_MODVERSION] = "You are attempting to connect to a server running version %i of the game '%s', but you only have version %i installed.  Continue anyway?";
	m_reslbl[IDS_CONN_FULL] = "Can't connect to %s, server is full.";
	m_reslbl[IDS_MOD_UNZIP] = "Do you want to uncompress the files for game '%s'?";
	m_reslbl[IDS_FAVSVRS_CORRUPT] = "The server data file favsvrs.dat appears to be corrupt.\r\n\r\nYou can request a new list of servers by pressing the Update button.\r\n\r\nDo you want to remove the corrupt file (you will have to re-enter your 'favorites' if you remove the file)?";

	/* Override the defaults with custom entries */
	stringslst = fopen("gfx/shell/strings.lst", FILE_READ);
	if (stringslst >= 0) {
		int lc;
		while((lstline = fgets(stringslst))) {
			lc = tokenize_console(lstline);
			if (lc == 2) {
				float i = stof(argv(0));
				/* you never know the vile stuff mods do. */
				if (i < m_reslbl.length) {
					m_reslbl[stof(argv(0))] = argv(1);
				}
			}
		}
		fclose(stringslst);
	}
}
